<?php // $Id: dsp_form_print.php,v 1.18 2004/10/11 10:42:45 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) 2001-2007 Mario Gleirscher                  *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * URL Parameter
 * backaction - Ruecksprungaction
 * labelset - evtl. gewaehltes Labelset 
 * 
 * Required PHP scripts:
 * act_lib.php 
 * qry/qry_labelsets.php
 * qry/qry_customers.php 
 *  
 */

// Parameter ueberpruefen
apxIsGet( 'backaction', 'sBackaction', 'plan' );

/* wird explizit gesetzt, wenn customerpr_ls_load im choose_labelset als _POST vorliegt */
apxIsPost( 'labelset', 'iLabelset', 'none' );
apxIsPost( 'lab_cols', 'iLab_cols', 3 );
apxIsPost( 'lab_rows', 'iLab_rows', 8 );
apxIsPost( 'lab_format', 'sLab_stylesheet', 'zweckform3474');

require_once( $apx_root_path.'qry/qry_labelsets.php' );

$aLabelset 				= array();
$iVarFormfields 	= 0;

?>

<form method="POST" name="choose_labelset" action="<?php echo $apx_script ?>?apx_a=customerpr">

<table class="apx_form">
<tr>
<td colspan="2" class="apx_headerbg">
	<span class="mgsubtitle">3. <?php echo( _( "Choose label preset ..." ) ); ?></span>
</td>
<td colspan="2" class="apx_mainbg">
<?php /* Liste der auswhlbaren Ettikettensets + Ladeoption */ ?>
  <select name="labelset" size="1">
    <option value="none"><?php echo _("No labelset chosen") ?></option>
  <?php
    if( is_array($qLabelSets->data) ) { 
	    foreach( $qLabelSets->data as $rowLabelset ) {
		  	echo( '<option ' ); 
				
				if( $iLabelset == $rowLabelset[ 'labelset_id' ] ) {
					echo( 'selected' ); 
					$aLabelset = explode( ',', $rowLabelset[ 'customers' ] );
					$sLabelset_name = $rowLabelset[ 'labelset_name' ];
				} 
				
				echo( ' value="'.$rowLabelset[ 'labelset_id' ].'">'.
						 $rowLabelset[ 'labelset_name' ].'</option>' );	
			} 
		}
	?>
      
  </select>
  <input type="submit" name="customerpr_ls_load" value="<?php echo _("Open"); ?>" />
  <input type="submit" name="customerpr_ls_del" value="<?php echo _("Delete"); ?>" />  
</td>
</tr>

<tr>
    <td class="apx_labelbg"><?php echo _( "Labels per row" ) ?>:</td>
    <td class="apx_mainbg" ><input type="text" size="10" name="lab_cols"
				   value="<?php echo $iLab_cols; ?>"> <?php echo _( "Pieces" ) ?></td>
    <td class="apx_labelbg"><?php echo _( "Labels per column" ) ?>:</td>
    <td class="apx_mainbg" ><input type="text" size="10" name="lab_rows"
				   value="<?php echo $iLab_rows; ?>"> <?php echo _( "Pieces" ) ?></td>
</tr>

<tr>
    <td class="apx_labelbg"><?php echo _( "Labels format" ) ?>:</td>
    <td class="apx_mainbg" colspan="3">
	<select name="lab_format" size="1">
	    <?php
	    foreach( $apx_labelformats as $keyLf => $valLf ) {
		echo '<option ';
		if( $keyLf == $sLab_stylesheet )
		    echo 'selected ';
		echo 'value="'.$keyLf.'">'.$valLf.'</option>' ;
	    }
	    ?>
	</select>
    </td>
</tr>
</table>

</form>



<form method="POST"
      id="printlabels"
      name="printlabels"
      onsubmit="return apxSubmitForm();">

<table class="apx_form">
<tr><td colspan="3" class="apx_headerbg">
<span class="mgsubtitle">4. 
<?php echo _( "Output address labels for printing ..." ) ?>
</span></td><td class="apx_controlbg">
<a href="<?php echo $apx_script ?>?apx_a=<?php echo $sBackaction ?>">
<img alt="<?php echo _( "Back" ) ?>" src="<?php echo $apx_imgpath ?>sym_left.gif"></a></td>
</tr>

<tr>
<td class="apx_labelbg" valign="top"><?php echo _( "Output format" ) ?>: </td>
<td colspan="3"  class="apx_mainbg">
    <input type="radio" name="outformat" value="css" checked>HTML/CSS (.htm)
    <input type="radio" name="outformat" value="html">HTML4 (.htm)<br/>
    <input type="radio" name="outformat" value="excel">Comma-Separated List (.csv)
    <input type="radio" name="outformat" value="text">ASCII-Text (.txt)
    <?php /*
    <input type="radio" name="outformat" value="word">&nbsp;MS&nbsp;Word&nbsp;-&nbsp;Text&nbsp;
    <input type="radio" name="outformat" value="pdf">&nbsp;Adobe&nbsp;PDF&nbsp;
    <input type="radio" name="outformat" value="xml">&nbsp;XML
    */ ?>
</td>
</tr>

<tr>
<td class="apx_labelbg" valign="top">&nbsp;</td>
<td colspan="3"  class="apx_mainbg">
    <input type="checkbox" name="multiplepages" value="yes" checked />
    <?php echo _( "Span output over several pages (for .htm and .txt)" ) ?>
</td>
</tr>


<tr>
<td class="apx_labelbg"></td>
<td colspan="3" class="apx_controlbg">
  <?php echo _( "Choose ..." ) ?>
  <select name="lab_page" size="1">
  <?php
    // label set selected?
    if( $iLabelset != 'none' ) {
      for($i = 0; $i < count($aLabelset) / ($iLab_cols * $iLab_rows); $i++) {
          echo( '<option value="'.($i + 1).'">'._("page ").($i + 1)."</option>" );
      }
    }
  ?>
  </select>
  <input type="submit" value="<?php echo _( "Show selected page ..." ) ?>"
         name="customerpr_submit"
	 onclick="document.pressed = this.name;" />
</td>
</tr>

<tr><td colspan="2" class="apx_headerbg">

<?php
/* Auswahlliste fuer Adressettiketten erzeugen in $iSelectAdressCols Spalten*/

$iSelectAdressCols = $apx_selectadresscols;
$iCusCount = $qListCount->data[ 0 ][ 'cuscount' ];
$iEntriesPerRow = Ceil($iCusCount / $iSelectAdressCols);
?>

<span class="mgsubtitle">1. 
    <?php printf( _( "Choose from %d items below ..." ),
                  $iCusCount ); ?>
</span><br />
<span class="mgtxtsmall"><?php echo _( "(No choice means to print all addresses!)" ) ?></span></td>
<td rowspan="2" colspan="2" class="apx_mainbg">
  <?php /* Speichern (unter) ... */ 
  echo( '<span class="mgsubtitle">2. '._( 'Save label preset ...' ).'</span><br/>' );
    
  if( $iLabelset != 'none' ) {
      echo( '<input type="submit" name="customerpr_ls_save" value="'._("Save current").'"
                    onclick="document.pressed = this.name;" />
               <input type="hidden" name="labelset" value="'.$iLabelset.'" />
               <input type="hidden" name="lab_rows" value="'.$iLab_rows.'" />
               <input type="hidden" name="lab_cols" value="'.$iLab_cols.'" />
               <input type="hidden" name="lab_format" value="'.$sLab_stylesheet.'" />' );
      $iVarFormfields += 2;
  }  
  ?>
    <input type="submit"
	   name="customerpr_ls_saveas"
	   value="<?php echo _("Save as new ..."); ?>"
           onclick="document.pressed = this.name;" />
    <input type="text"
	   name="labelset_newname"
	   value="<?php echo _("New_Labelset"); ?>" 
	   size="20"
	   maxlength="50" />
</td>
</tr>
<tr>
    <td colspan="2" class="apx_mainbg">
	<a href="javascript:chooseAllCheckboxes( document.printlabels, 12 + <?php echo $iVarFormfields; ?>, <?php echo $iCusCount ?>, true )">
	    <?php echo _( "Mark all" ) ?></a> |
	<a href="javascript:chooseAllCheckboxes( document.printlabels, 12 + <?php echo $iVarFormfields; ?>, <?php echo $iCusCount ?>, false )">
	    <?php echo _( "Unmark all" ) ?></a>
    </td>
</tr>
<tr><td class="apx_mainbg" colspan="4">

<?php
if( is_object( $qListData ) ) {
    echo '<table class="apx_layout"><tr>';
    $iCounter = 1;
    $iRowCounter = 0;

    echo( '<td class="apx_mainbg">' );
    foreach( $qListData->data as $rowCustomers ) {

        /* Liste von Kunden ausgeben und ggf. markieren anhand 
				   einer ausgewhlten Ettikettenliste */
        echo( '<input type="checkbox" name="cus'.
              ($iCounter + $iEntriesPerRow * $iRowCounter).
              '" value="'.
              $rowCustomers[ 'customer_id' ].
              '"' ); 
        
				/* wenn ein Labelset oben gewhlt, dann entsprechende Eintrge vormarkieren */      
				if( $iLabelset != 'none' && 
				    in_array( $rowCustomers[ 'customer_id' ], $aLabelset ) )
					echo( ' checked' );
				
				echo( ' >'.
              $rowCustomers[ 'lastname' ].', '.
              $rowCustomers[ 'firstname' ].'<br/>'."\n" );

        if (($iCounter + $iEntriesPerRow * $iRowCounter) < $iCusCount &&
            ($iCounter >= $iEntriesPerRow)) {
            echo( '</td><td class="apx_mainbg">' );
            $iRowCounter++;
            $iCounter = 0;
        }
        else if (($iCounter * $iRowCounter) >= $iCusCount)
            echo( '</td>' );


        $iCounter++;
    }
    echo '</tr></table>';
}
else {
    trigger_error( _( "No items could have been found!" ),
                   E_USER_NOTICE );
}
?>

</td></tr>
</table>
</form>

<script type="text/javascript">
 function apxSubmitForm()
 {
     if(document.pressed == 'customerpr_submit') {
	 document.printlabels.action = "dsp_print.php?apx_a=labelprint";
	 document.printlabels.target = "_blank";
     }
     else if(document.pressed == 'customerpr_ls_save' ||
	     document.pressed == 'customerpr_ls_saveas' ) {
	 document.printlabels.action = "<?php echo $apx_script; ?>?apx_a=customerpr";
     }
     return true;
 }
</script>


