<?php // $Id: dsp_form_search.php,v 1.17 2004/10/11 10:42:45 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) 2001-2005 Mario Gleirscher                  *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * URL Parameter
 * backaction - Ruecksprungaction
 * firstname (optional)
 * lastname (optional)
 */

// Einige Parameter ueberpruefen
apxIsGet( 'backaction', 'sBackaction', 'customerdb' );

$sCustomerTitle = _( 'Search results' );

?>


<form name="search" action="<?php echo $apx_script ?>" method="GET">

<input type="hidden" name="apx_a" value="search">

<table class="apx_form">
<tr><td class="apx_headerbg">
<span class="mgsubtitle"><?php echo _( "Search for customer" ) ?></span></td>
<td class="apx_controlbg">
    <a href="<?php echo $apx_script ?>?apx_a=<?php echo $sBackaction ?>">
    <img alt="<?php echo _( "Back" ) ?>" src="<?php echo $apx_imgpath ?>sym_left.gif"></a>
</td>
</tr>

<tr>
<td colspan="2" class="apx_mainbg">
    <?php echo _( "<STRONG>Hint:</STRONG> You have to fill in at least one form field! The search will be case-insensitive!" ) ?>
</td>
</tr>


<?php

// Array von Suchfeldern
// [ Suchfeld (DB) ][ Feldtyp ][ Generiere Formularzeile? ][ Formzeilenname ][ prio (fett?) ]
// 0 = Integer/Double
// 1 = String
$aSearchFields = array(
    0 => array( 0 => 'customer_id', 1 => 0, 2 => 1, 3 => _( 'Customer no.:' ),  4 => 0 ),
    1 => array( 0 => 'lastname',    1 => 1, 2 => 1, 3 => _( 'Lastname:' ),      4 => 1 ),
    2 => array( 0 => 'firstname',   1 => 1, 2 => 1, 3 => _( 'Firstname:' ),     4 => 1 ),
    3 => array( 0 => 'zip',         1 => 1, 2 => 1, 3 => _( 'ZIP:' ),           4 => 0 ),
    4 => array( 0 => 'place',       1 => 1, 2 => 1, 3 => _( 'Place:' ),         4 => 0 ),
    5 => array( 0 => 'country_id',  1 => 0, 2 => 0, 3 => _( 'Country:' ),       4 => 0 ),
    6 => array( 0 => 'email',       1 => 1, 2 => 1, 3 => _( 'E-mail:' ),        4 => 0 ),
    7 => array( 0 => 'nickname',    1 => 1, 2 => 1, 3 => _( 'Nickname:' ),      4 => 0 ),
    8 => array( 0 => 'phone',       1 => 1, 2 => 1, 3 => _( 'Phone number:' ),  4 => 0 )
    );

// Suchmuster generieren
$bDisplay = false;
$sSearchPattern = '';
$sTblPrefix = 'ac';

for( $i = 0; $i < count( $aSearchFields ); $i++ ) {
    // Variable dyn. anlegen
    if ( $aSearchFields[ $i ][ 1 ] ) {
        $sPrefix = 's_';
        $sType   = 'string';
    }
    else {
        $sPrefix = 'i_';
        $sType   = 'integer';
    }

    $sNewVariable   = $sPrefix.$aSearchFields[ $i ][ 0 ];
    settype( $$sNewVariable, $sType );

    // Variable erzeugen
    if ( $aSearchFields[ $i ][ 1 ] )
        $$sNewVariable = '';
    else
        $$sNewVariable = 0;


    $bVariableFull = false;

    // per HTTP uebergebenen Wert uebernehmen
    if ( isset( $_GET[ $aSearchFields[ $i ][ 0 ] ] ) ) {
        $$sNewVariable  = trim( $_GET[ $aSearchFields[ $i ][ 0 ] ] );

        if ( $aSearchFields[ $i ][ 1 ] )
            $bVariableFull = $$sNewVariable != '';
        else
            $bVariableFull = $$sNewVariable != 0;
        $bDisplay = $bDisplay || $bVariableFull;
    }

    // Suchermuster fuer SQL-Answeisung generieren
    if ( $bVariableFull ) {
        if ( $sSearchPattern != '' )
            $sSearchPattern .= ' AND ';

        // fuer Strings
        if ( $aSearchFields[ $i ][ 1 ] ) {
            $sSearchPattern .= ( $$sNewVariable != '' )
                               ?
                               apxDb_retInstr( $sTblPrefix.'.'.
                                            $aSearchFields[ $i ][ 0 ],
                                            $$sNewVariable,
                                            $apx_dbsys )
                               : '';
        }
        // fuer Integers
        else {
            $sSearchPattern .= $$sNewVariable
                               ?
                               $sTblPrefix.'.'.$aSearchFields[ $i ][ 0 ].
                               ' = '.$$sNewVariable
                               : '';
        }
    }

    // HTML-Formularzeile generieren
    if ( $aSearchFields[ $i ][ 2 ] ) {
        echo '<tr>
              <td class="apx_labelbg">'.
              ( $aSearchFields[ $i ][ 4 ] ? '<strong>' : '' ).
              $aSearchFields[ $i ][ 3 ].
              ( $aSearchFields[ $i ][ 4 ] ? '</strong>' : '' ).
              '</td><td class="apx_mainbg">
                  <input type="text" name="'.$aSearchFields[ $i ][ 0 ].'"
                         size="50" maxlength="70"
                         value="'.( $$sNewVariable ? $$sNewVariable : '' ).'" />
              </td>
              </tr>';
    }
}

if ( $sSearchPattern != '' )
    $sSearchPattern = 'WHERE '.$sSearchPattern;

?>


<tr>
<td class="apx_labelbg"><?php echo _( "Country" ) ?>:</td>
<td class="apx_mainbg">
<select size="1" name="country_id">
<?php
foreach( $qCountries->data as $rowCountries ) {
    $qr_country_id  = $rowCountries[ 'country_id' ];
    $qr_countryname = $rowCountries[ 'country' ];
    $qr_priorshow   = $rowCountries[ 'priorshow' ];

    echo( "<option value=\"$qr_country_id\"" );

    if( $qr_country_id == $i_country_id )
        echo( "selected" );

    if( $qr_country_id )
        echo( ">".( $qr_priorshow ? '&gt;&nbsp;' : '' ).
            "$qr_countryname&nbsp;&nbsp;</option>\n" );
    else
        echo( ">&gt;&nbsp;"._( "No country specified!" )."&nbsp;&nbsp;</option>\n" );
}
?>
</select>
</td>
</tr>

<tr>
<td class="apx_labelbg">&nbsp;</td>
<td class="apx_controlbg">
    <input type="submit" value="<?php echo _( "Start search" ) ?>" name="submit">
    <input type="reset" value="<?php echo _( "Reset" ) ?>" name="reset">
    <a href="javascript:{empty_formfields( document.search ); document.search.lastname.focus();}"><img
    alt="<?php echo _( "Empty all formfields" ) ?>" src="<?php echo $apx_imgpath ?>sym_clearfields.gif"
    align="top"></a>
</td>
</tr>

</table>

</form>

<script language="javascript">
<!--
document.search.lastname.focus();
//-->
</script>

<?php
// Suchergebnisse anzeigen, falls moeglich
if( $bDisplay ) {
    include( $apx_root_path.'qry/qry_customers.php' );

    if( !$iListCount ) {
        trigger_error( _( "No items according to the search information have been found!" ), E_USER_NOTICE );
    }
    else {
        include( "dsp_customers.php" );
    }
}

?>
