<?php // $Id: dsp_list.php,v 1.15 2004/10/11 10:42:46 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * Required files:
 * - act_lib.php
 * -
 *
 * Parameter:
 * -
 */


apxIsGet( 'backaction', 'sBackaction', $sSList->url_action );

if( apxIsGet( 'do', '', '', true, 'm' ) &&
    apxIsGet( 'proc', '', '', true, '1' ) ) {
    $s_multidelquery = 'DELETE FROM '.$apx_dbtableprefix.$sSList->dbtable.
                       ' WHERE '.$sSList->edit_idfield.' IN (';

    reset( $_POST );
    $i_commacount = 0;
    while( list( $cur_key, $cur_val ) = each( $_POST ) ) {
        if( strstr( $cur_key, 'item_' ) )
            $s_multidelquery .= ( $i_commacount++ ? ', ' : '' ).$cur_val;
    }

    $s_multidelquery .= ')';

    $q_multidel = $i_commacount && $apx_dbc->query( $s_multidelquery );

    if( $q_multidel )
        trigger_error( _( "The chosen (marked) items are finally deleted from the database." ),
                       E_USER_NOTICE );
    else
        trigger_error( _( "No items have been marked and, thus, none have been deleted." ),
                       E_USER_WARNING );
}

///////////////////////////////////////////////////////////////////////////
// Eintragsfilter und Suchmaske
if( $sSList->filter ) {
    apxIsPostGetSame( 'rpp', 'iRowsPerPage', $apx_rowsperpage );
    apxIsGet( 'offset', 'iOffset' );

    // Query-Suchstring aus Filterkriterien generieren
    $sSearchPattern = '';

    reset( $sSList->filter_crits );
    while( list( $curKey, $curCrit ) = each( $sSList->filter_crits ) ) {
        $sPatternPart   = '';

        apxIsPostGetSame( $curCrit[ 'field' ], $curCrit[ 'vartoset' ], $curCrit[ 'default' ] );

        if( $curCrit[ 'type' ] == 'num' ) {
            $sPatternPart = ( ${$curCrit[ 'vartoset' ]} != $curCrit[ 'default' ] ?
                                 $curCrit[ 'crit' ].' = '.${$curCrit[ 'vartoset' ]} : '' );
        }
        elseif( $curCrit[ 'type' ] == 'str' ) {
            if( $apx_dbsys == 'odbc' )
                $s_strcompfunc = 'StrComp';
            else
                $s_strcompfunc = 'STRCMP';
            $sPatternPart = ( ${$curCrit[ 'vartoset' ]} != $curCrit[ 'default' ] ?
                              $s_strcompfunc.'( \''.${$curCrit[ 'vartoset' ]}.
                              '\', UCase(Left( '.$curCrit[ 'crit' ].', 1 ))'.
                              ( $apx_dbsys == 'odbc' ? ', 1' : '' ).' ) = 0' : '' );
        }
        elseif( $curCrit[ 'type' ] == 'bool' ) {
            $sPatternPart = ( ${$curCrit[ 'vartoset' ]} != $curCrit[ 'default' ] ?
                                 'ABS( '.$curCrit[ 'crit' ].' ) = '.${$curCrit[ 'vartoset' ]} : '' );
        }

        if( trim( $sPatternPart ) != '' ) {
            if( trim( $sSearchPattern ) != '' )
                $sSearchPattern .= ' AND ';
            $sSearchPattern .= $sPatternPart;
        }
    }

    if( trim( $sSearchPattern ) != '' )
        $sSearchPattern = trim( 'WHERE '.$sSearchPattern );
}
///////////////////////////////////////////////////////////////////////////

// Datenbankabfrage starten
include( $apx_root_path.'qry/qry_'.$sSList->dbquery_script.'.php' );

// Anzahl der Datensaetze ermitteln (wenn Counter Query existiert, wurde
// $iListCount schon gesetzt)
if( trim( $sSList->cntquery ) == '' )
    $iListCount = is_object( ${$sSList->dbquery} ) ? ${$sSList->dbquery}->rows : 0;

if( !$sSList->filter ) {
    $iRowsPerPage = $iListCount;
    $iOffset = 0;
}

$i_interval = ( $iRowsPerPage == '--' ) ? $iListCount : $iRowsPerPage;

// Buchstabenauswahlbalken generieren
// Beim Filter gibt es immer mindestens 1 Kriterium, und davon genau
// 1 Krit. mit str fr Anfangsbuchstaben
if( $sSList->letters ) {
    $sLetterbar = '';
    $sLBPart1 = '<a href="'.$apx_script.'?apx_a='.$sSList->url_action.
                '&'.$sSList->filter_crits[ 0 ][ 'field' ].'=';

    $sLBPart2 = '';
    reset( $sSList->filter_crits );
    next( $sSList->filter_crits ); // wegen letterCrit
    while( list( $curKey, $curCrit ) = each( $sSList->filter_crits ) )
        $sLBPart2 .= '&'.$curCrit[ 'field' ].'='.${$curCrit[ 'vartoset' ]};

    $sLBPart2 .= '&rpp='.$iRowsPerPage.'">[';

    for( $i = 65; $i < 91; $i++ )
        $sLetterbar .= $sLBPart1.Chr( $i ).$sLBPart2.Chr( $i ).']</a> ';
}

$sOldLetter = '%';

$iColumns = count( $sSList->columns );


if( !$iListCount || !is_object( ${$sSList->dbquery} ) ) {
    trigger_error( $sSList->msg_emptylist, E_USER_NOTICE );
    return;
}
?>

<table class="apx_list">

<?php if( $sSList->filter ): // Filter ?>
<tr><td colspan="<?php echo $iColumns ?>" class="apx_mainbg">

<form name="listfilter" action="<?php echo( $apx_script.'?apx_a='.$sSList->url_action ); ?>"
      method="POST">
<table class="apx_list" style="width:100%">
<tr>
<td colspan="<?php echo( count( $sSList->filter_crits ) * 2 + 1 ); ?>" class="apx_headerbg">
    <span class="mgsubtitle"><?php echo _( "Put filter upon list" ) ?>:</span>
</td>
</tr>
<tr>
<?php include( $apx_root_path.'dsp/dsp_'.$sSList->dbquery_script.'_filter.php' ); ?>
<td class="apx_controlbg"><input type="submit" value="<?php echo _( "Use filter" ) ?>"></td>
</tr><tr>
<td class="apx_labelbg"><?php echo _( "Items per page" ) ?>:</td>
<td class="apx_mainbg">
    <select size="1" name="rpp" >
    <option value="--"><?php echo _( "All" ).'('.$iListCount ?>)</option>
    <?php
    for( $i = 10; $i <= 100; $i += 10 ) {
        echo '<option value="'.$i.'" ';
        echo ( $i == $iRowsPerPage ) ? ' selected ' : '';
        echo '>'.$i.'</option>';
    }
    ?>
    </select>
</td>
<td colspan="<?php echo( count( $sSList->filter_crits ) * 2 - 1 ); ?>" " class="apx_mainbg">
    <?php
    $sFilterStr = '';
    reset( $sSList->filter_crits );
    while( list( $curKey, $curCrit ) = each( $sSList->filter_crits ) )
          $sFilterStr .= '&'.$curCrit[ 'field' ].'='.${$curCrit[ 'vartoset' ]};

    if( $iOffset - $i_interval >= 0) {
        echo( '<a href="'.$apx_script.'?apx_a='.$sSList->url_action.
              $sFilterStr.'&offset='.( $iOffset - $i_interval ).
              '&rpp='.$i_interval.'">[&lt;&lt; zur&uuml;ck]</a> | ' );
    }

    if( ( $iOffset + $i_interval ) < $iListCount ) {
        echo( '<a href="'.$apx_script.'?apx_a='.$sSList->url_action.
              $sFilterStr.'&offset='.( $iOffset + $i_interval ).
              '&rpp='.$i_interval.'">[vor &gt;&gt;]</a> | ' );
    }

    echo( _( ' Show item range: ' ) );

    for( $i = 0; $i < $iListCount; $i += $i_interval ) {
        if( !( $i >= $iOffset && $i < ($iOffset + $i_interval) ) ) {
            echo( '<a href="'.$apx_script.'?apx_a='.$sSList->url_action );
            echo( $sFilterStr.'&offset='.$i.'&rpp='.$iRowsPerPage.'">' );
        }

        echo( '['.($i + 1).'-'.
              ( $iListCount < ($i + $i_interval) ? $iListCount : ($i + $i_interval) ).
              ']' );

        if( !( $i >= $iOffset && $i < ($iOffset + $i_interval) ) )
            echo( '</a>'."\n" );
    }
    ?>
</td></tr></table> </form>

</td>
</tr>
<?php endif; // Filter ?>

<?php
// Formular fuer die Mehrfachloeschung
if( $sSList->multidel )
    echo( '<form name="multidel" method="POST" action="'.
          $apx_script.'?apx_a='.$sSList->url_action.'&do=m&proc=1">' );
?>

<tr><td colspan="<?php echo( $iColumns < 2 ? 1 : $iColumns - 1 ); ?>" class="apx_headerbg">
    <span class="mgtitle"><?php echo $sSList->title ?></span><br />
    (
    <?php
        echo( _( "Items" ).' '.( $iOffset + 1 ).' '._( 'from' ).' '.
              ( $iListCount < ( $iOffset + $i_interval ) ? $iListCount : ( $iOffset + $i_interval ) ) ).
              ' '._( "to" ).' ';
        echo( $iListCount );
        echo( trim( $sSList->msg_orderby ) != '' ? _( ', ordered by' ).' '.$sSList->msg_orderby : '' );
    ?>)</td>
    <td class="apx_controlbg">
    <a href="<?php echo( $apx_script.'?apx_a='.$sSList->url_rowaction.
                   '&do=i&backaction='.$sSList->url_action.$sSList->spec_action ); ?>">
      <img title="<?php echo $sSList->msg_createrow ?>" src="<?php echo $apx_imgpath ?>sym_new.gif"
      onMouseover="return dispStatus('<?php echo $sSList->msg_createrow ?>')"
      onMouseout="return dispStatus('')"></a>
    <a href="<?php echo $apx_script ?>?apx_a=<?php echo $sBackaction ?>">
    <img onMouseover="return dispStatus('<?php echo _( "Back" ) ?>')"
         onMouseout="return dispStatus('')"
         title="<?php echo _( "Back" ) ?>"
         src="<?php echo $apx_imgpath ?>sym_left.gif" align="middle" /></a>
</td></tr>

<?php
if( $sSList->letters )
    echo( '<tr><td class="apx_mainbg" colspan="'.$iColumns.'">'.$sLetterbar.'</td></tr>' );
?>

<tr>
<?php
// Spaltenkoepfe ausgeben
reset( $sSList->columns );
while( list( $curKey, $curCol ) = each( $sSList->columns ) ) {
    echo( '<td '.( $iColumns < 2 ? 'colspan="2"' : '' ).' class="apx_headerbg2" >'.
          '<span class="mgsubtitle">'.$curCol[ 'header' ].'</span></td>' );
}
?>
</tr>


<?php

foreach( ${$sSList->dbquery}->data as $rowData ) {
    $sCurLetter = strtoupper( substr( $rowData[ $sSList->letters_dbfield ], 0, 1 ) );

    // Trennzeile fuer Buchstabenwechsel ausgeben
    if( $sSList->letters && $sOldLetter !=  $sCurLetter) {
      $sOldLetter = $sCurLetter;
      echo( "<tr><td class=\"apx_headerbg\" colspan=\"".( $iColumns < 2 ? 1 : $iColumns - 1 )."\">
             <a name=\"$sOldLetter\"></a>
             <span class=\"apx_letter\">[ $sOldLetter ]</span></td>
             <td class=\"apx_controlbg\">
             <a href=\"#top\"><img title=\""._( "To the top" )."\" src=\"".$apx_imgpath.
             "sym_up.gif\"
             onMouseover=\"return dispStatus('"._( "To the top" )."')\"
             onMouseout=\"return dispStatus('')\"></a>
             <a href=\"#bottom\"><img title=\""._( "To the bottom" )."\"
             src=\"".$apx_imgpath."sym_down.gif\"
             onMouseover=\"return dispStatus('"._( "To the bottom" )."')\"
             onMouseout=\"return dispStatus('')\"></a>
             <a href=\"$apx_script?apx_a=".$sSList->url_rowaction.
             "&do=i&backaction=$sSList->url_action$sSList->spec_action\">
             <img title=\"$sSList->msg_createrow\" src=\"".$apx_imgpath.
             "sym_new.gif\"
             onMouseover=\"return dispStatus('".$sSList->msg_createrow."')\"
             onMouseout=\"return dispStatus('')\">
             </a></td></tr>" );
    }

    // Listenzeile ausgeben
    echo( '<tr onMouseover="setPointer(this, \'apx_mainbghl\')"
               onMouseout="setPointer(this, \'apx_mainbg\')">' );

    $sEditString =
             '<a href="'.$apx_script.'?apx_a='.$sSList->url_rowaction.
             '&do=u&id='.$rowData[ $sSList->edit_idfield ].'">
              <img title="'._( "view/edit" ).'" src="'.$apx_imgpath.'sym_edit.gif"
              onMouseover="return dispStatus(\''._( "view/edit" ).'\')"
              onMouseout="return dispStatus(\'\')" /></a>'.
              ( !( $rowData[ $sSList->edit_idfield ] || $sSList->sysdel ) ?
              ' System ' :
              '<a href="'.$apx_script.'?apx_a='.$sSList->url_rowaction.
              '&do=d&id='.$rowData[ $sSList->edit_idfield ].'">
              <img title="'._( "Delete" ).'" src="'.$apx_imgpath.'sym_delete.gif"
              onMouseover="return dispStatus(\''._( "Delete" ).'\')"
              onMouseout="return dispStatus(\'\')" /></a>' );

    if( $sSList->multidel ) {
        $sEditString .= ' &nbsp;<input type="checkbox" name="item_'.
                        $rowData[ $sSList->edit_idfield ].'" value="'.
                        $rowData[ $sSList->edit_idfield ].'" />';
    }

    reset( $sSList->columns );
    while( list( $curKey, $curCol ) = each( $sSList->columns ) ) {

        $curCSSClass = trim( $curCol[ 'cssclass' ] ) != '' ?
                       $curCol[ 'cssclass' ] : 'apx_mainbg';

        if( $curCol[ 'type' ] == 's' ) {        // (s)imple
            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." class=\"$curCSSClass\">".
                 $rowData[ $curCol[ 'cellcontent' ] ]."&nbsp;</td>\n";
        }
        else if( $curCol[ 'type' ] == 'c' ) {   // (c)onstant
            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." class=\"$curCSSClass\">".
                 $curCol[ 'cellcontent' ]."&nbsp;</td>\n";
        }
        else if( $curCol[ 'type' ] == 'w' ) {   // (w)aehrung: currency + accounting amount
            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." style=\"text-align:right\" ".
                 "class=\"$curCSSClass\"> ".
                 apxOutCur( $apx_curstring, $rowData[ $curCol[ 'cellcontent' ] ], 'l' ).
                 "&nbsp;</td>\n";
        }
        else if( $curCol[ 'type' ] == 'b' ) {   // (b)ool
            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." class=\"$curCSSClass\">";
            $aCurFields = explode( ";", $curCol[ 'cellcontent' ] );
            echo ( $rowData[ $aCurFields[ 0 ] ] ? $aCurFields[ 1 ] : $aCurFields[ 2 ] );
            echo "&nbsp;</td>\n";
        }
        else if( $curCol[ 'type' ] == 'a' ) {   // (a)rray
            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." class=\"$curCSSClass\">";
            $aCurFields = explode( ";", $curCol[ 'cellcontent' ] );
            echo ${$aCurFields[ 1 ]}[ $rowData[ $aCurFields[ 0 ] ] ];
            echo "&nbsp;</td>\n";
        }
        else if( $curCol[ 'type' ] == 'd' ) {   // (d)ate
            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." class=\"$curCSSClass\">".
                  date( $apx_dateformat, strtotime( $rowData[ $curCol[ 'cellcontent' ] ] ) ).
                  "&nbsp;</td>\n";
        }
        else if( $curCol[ 'type' ] == 'p' ||    // (p)attern
                 $curCol[ 'type' ] == 'e' ) {   // (e)dit

            echo '<td '.( $iColumns < 2 ? 'colspan="2"' : '' ).' class="'.
                 ( $curCol[ 'type' ] == 'p' ? $curCSSClass : 'apx_controlbg' ).'">';

            $aMatches = array();
            $sCellContent = $curCol[ 'cellcontent' ];

            // Variablen finden und ersetzen
            // [= =] globale,
            // [? ?] aus sSList,
            // [( )] aus DB
            $bMatches = true;
            while( $bMatches ) {
                $bMatches = false;
                if( preg_match( "/\[=([a-z_]*)=\]/i", $sCellContent, $aMatches ) ) {
                    $bMatches = $bMatches || true;
                    $sCellContent = preg_replace( "/\[=".$aMatches[ 1 ]."=\]/i",
                                    ${$aMatches[ 1 ]}, $sCellContent );
                }
                if( preg_match( "/\[\?([a-z_]*)\?\]/i", $sCellContent, $aMatches ) ) {
                    $bMatches = $bMatches || true;
                    $sCellContent = preg_replace( "/\[\?".$aMatches[ 1 ]."\?\]/i",
                                    $sSList->{$aMatches[ 1 ]}, $sCellContent );
                }
                if( preg_match( "/\[\(([a-z_]*)\)\]/i", $sCellContent, $aMatches ) ) {
                    $bMatches = $bMatches || true;
                    $sCellContent = preg_replace( "/\[\(".$aMatches[ 1 ]."\)\]/i",
                                    $rowData[ $aMatches[ 1 ] ], $sCellContent );
                }
            }

            echo( $sCellContent.'&nbsp;'.
                  ( $curCol[ 'type' ] == 'e' ? $sEditString : '' ).
                  "&nbsp;</td>\n" );
        }
        else if( $curCol[ 'type' ] == 'i' ) {   // (i)nclude
            echo( '<td '.( $iColumns < 2 ? 'colspan="2"' : '' )." class=\"$curCSSClass\">" );
            include( $curCol[ 'cellcontent' ] );   // Erzeugt $sCellContent
            echo( $sCellContent."&nbsp;</td>\n" );
        }
    }
    echo '</tr>';

    $sOldLetter = $sCurLetter;
}

if( $sSList->letters )
    echo( '<tr><td class="apx_mainbg" colspan="'.( $iColumns < 2 ? 2 : $iColumns ).'">'.
          $sLetterbar.'</td></tr>' );
?>

<?php
if( $sSList->multidel ) {
    echo '<tr><td class="apx_controlbg" colspan="'.( $iColumns < 2 ? 2 : $iColumns ).'">';

    if( $sSList->multimark ) {
        $i_itemstomark = $iListCount < $i_interval ? $iListCount : $i_interval;
        echo( '<a href="javascript:chooseAllCheckboxes( window.document.multidel, 0, '.
              $i_itemstomark.', true )">'.
              _( "All" ).'</a> | <a href="javascript:chooseAllCheckboxes( window.document.multidel, 0, '.
              $i_itemstomark.', false )">'.
              _( "None" ).'</a> '._( "items shall be marked" ).'&nbsp;&nbsp;&nbsp;' );
    }

    echo( '<input type="submit" name="multidel"
          value="'._( "Delete marked items" ).'" /><br />' );
    echo( '<span class="mgtxt">'.
          _( "<strong>Attention:</strong> Deletion by marking is done without confirmation!" ).
          '</span></tr>' );
}
?>

<tr><td class="apx_controlbg" colspan="<?php echo ( $iColumns < 2 ? 2 : $iColumns ) ?>">
<a href="<?php echo( $apx_script.'?apx_a='.$sSList->url_rowaction.
                     '&do=i&backaction='.$sSList->url_action.$sSList->spec_action ); ?>">
    <img title="<?php echo $sSList->msg_createrow ?>" src="<?php echo $apx_imgpath ?>sym_new.gif"
    onMouseover="return dispStatus('<?php echo $sSList->msg_createrow ?>')"
    onMouseout="return dispStatus('')"></a>

<a href="#top"><img title="<?php echo _( "To the top" ) ?>" src="<?php echo $apx_imgpath ?>sym_up.gif"
    onMouseover="return dispStatus('<?php echo _( "To the top" ) ?>')"
    onMouseout="return dispStatus('')"></a></tr>

<?php
// Formular fuer die Mehrfachloeschung
if( $sSList->multidel )
    echo( '</form>' );
?>

</table>

