<?php // $Id: dsp_plan.php,v 1.30 2004/10/11 10:42:46 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) 2001-2005 Mario Gleirscher                  *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * URL Parameter (GET):
 * - date_begin - anzuzeigender Monat
 * - date_end - anzuzeigendes Jahr
 * - dateframe
 * - hlb
 * - planroom_id
 * - planobj_id
 * - season
 */

// Parameter
$curdate    = getdate( time() );
$startdate  = mktime( 0, 0, 0, $curdate[ 'mon' ], $curdate[ 'mday' ] - $apx_stddos_b , $curdate[ 'year' ] );
$enddate    = mktime( 0, 0, 0, $curdate[ 'mon' ], $curdate[ 'mday' ] + $apx_stddos_e , $curdate[ 'year' ] );
$s_urlparam = $s_urlparam_s = '';

// Wenn Saison angegeben wurde
if( apxIsPostGet( 'season', 'season', 'url_season_id' ) ) {
    $s_searchstring = 'WHERE season_id = '.$url_season_id;
    require( $apx_root_path.'qry/qry_seasons.php' );

    $_GET[ 'date_begin' ] = $qSeasons->data[ 0 ][ "start" ];
    $_GET[ 'date_end' ]   = $qSeasons->data[ 0 ][ "end" ];

    $s_seasonstr = $apx_season_maintypes[ $qSeasons->data[ 0 ][ "maintype" ] ].' / '.
                   $apx_season_subtypes[ $qSeasons->data[ 0 ][ "subtype" ] ];

    $s_urlparam_s = '&season='.$url_season_id;
}
else {
    $s_seasonstr = 'Zeitraum';
}

// Datumsangaben verarbeiten
if( apxIsGet( 'date_begin' ) ) {
    $s_year     = substr( $_GET[ 'date_begin' ], 0, 4 );
    $s_month    = substr( $_GET[ 'date_begin' ], 5, 2 );
    $s_day      = substr( $_GET[ 'date_begin' ], 8, 2 );

    // bei hlb zeigen wir immer 5 Tage vorher und nachher an
    if( apxIsGet( 'dateframe' ) )
        $startdate = mktime( 0, 0, 0, $s_month, $s_day - $apx_plan_dateframe_size, $s_year );
    else
        $startdate = mktime( 0, 0, 0, $s_month, $s_day, $s_year );
}

if( apxIsGet( 'date_end' ) ) {
    $e_year     = substr( $_GET[ 'date_end' ], 0, 4 );
    $e_month    = substr( $_GET[ 'date_end' ], 5, 2 );
    $e_day      = substr( $_GET[ 'date_end' ], 8, 2 );

    // bei hlb zeigen wir immer 5 Tage vorher und nachher an
    if ( apxIsGet( 'dateframe' ) )
        $enddate = mktime( 0, 0, 0, $e_month, $e_day + $apx_plan_dateframe_size, $e_year );
    else
        $enddate = mktime( 0, 0, 0, $e_month, $e_day, $e_year );
}

// Buchungseintrag herausheben ( hlb = highlight booking )
if( apxIsGet( 'hlb', 'i_hl_booking' ) )
    $s_urlparam = '&hlb='.$i_hl_booking;

if( apxIsGet( 'planroom_id', 'i_planroom_id' ) )
    $s_urlparam .= '&planroom_id='.$_GET[ 'planroom_id' ];

if( apxIsGet( 'planobj_id', 'i_planobj_id' ) )
    $s_urlparam .= '&planobj_id='.$i_planobj_id;

if( !apxIsPostGet( 'season' ) &&
    apxIsGet( 'date_begin' ) && apxIsGet( 'date_end' ) )
    $s_urlparam_s = '&date_begin='.$_GET[ 'date_begin' ].
                    '&date_end='.$_GET[ 'date_end' ];


// In Plan Infos anzeigen?
// Buchungsdaten anzeigen, wenn Benutzer eingeloggt ist und Typ <= 3 hat.
if( $bAccess && $apx_auth_usertype <= 3 )
    $b_showinfo = true;
else
    $b_showinfo = false;

// Datumsangaben konvertieren
$aStartDate = getdate( $startdate );

// Differenz in Tagen berechnen
$iPeriodlength = $enddate - $startdate;
$period = getdate( $iPeriodlength );
$years = $period[ 'year' ] - 1970;
$days = $period[ 'yday' ];
// Tageszahl berechnen, Schaltjahrtage dazuzhlen ( + 1 fuer den 1. Tag incl. )
$iPeriodlength = ( $years * 365 ) + intval( $years / 4 ) + $days + 1;

// Plan anzeigen: Fuer jede Rumlichkeit eine Tabellenzeile generieren
$bShowDummy = false;
require( $apx_root_path.'qry/qry_roomdata.php' );

// ------------------------------------------------
// Wenn die Anzeigeperiode zu lang (>999) ist, dann die Anzeige des Planes wegen HTML-Anzeigefehlern abbrechen
// wegen colspan="i" mit i > 1000
if( $iPeriodlength > 999 ):
    trigger_error( $apx_errors[ 3 ], E_USER_WARNING );

else:

?>

<table class="apx_plan">
<tr><td class="apx_headerbg" colspan="<?php echo( $iPeriodlength * 2 + 1 ) ?>">
    <span class="mgsubtitle" style="font-size:<?php echo $apx_planfontsize + 1 ?>pt;">
    <?php
    echo _( "Occupancy table of the rooms " );

    if( $b_showinfo ) {
        if( $i_planobj_id ) {
            echo _( 'of the rental object ' ).' &quot;['.$qRoomData->data[ 0 ][ "objnr" ].'] '.
                 $qRoomData->data[ 0 ][ "objname" ].'&quot; ';
        }
        elseif( !$i_planroom_id ) {
            echo _( 'of all rental objects ' );
        }
    }
    ?>
    </span>
    <span class="mgemph" style="font-size:<?php echo $apx_planfontsize + 1 ?>pt;">[
    <?php
    echo $s_seasonstr;
    echo ': '.strftime( "%d. %B %Y", $startdate ).' - '.strftime( "%d. %B %Y", $enddate );
    ?>
    ]</span>
</td></tr>

<tr>
<td class="apx_headerbg"><span style="font-size:1px">&nbsp;</span></td>
<?php
    // Damit manche Zellen nicht zu schmal werden, dies verbessert die
    // Lesbarkeit des Planes
    for ( $i = 0; $i < $iPeriodlength * 2; $i++ )
        echo "<td class=\"apx_headerbg\"><img src=\"".$apx_imgpath."pix_invisible.gif\" width=\"".
             ( round( $apx_planfontsize ) - 1 )."\" height=\"1\"></td>";
?>
</tr>

<?php if( $b_showinfo ): ?>
<tr>
<td class="apx_controlbg" colspan="<?php echo( $iPeriodlength * 2 + 1 ) ?>">
    <form action="<?php echo $apx_script.'?apx_a=plan'.$s_urlparam ?>" method="POST">
    <?php echo _( "Season" ) ?>:
    <select name="season" size="1">
    <?php
    $s_searchstring = '';
    include( $apx_root_path.'qry/qry_seasons.php' );
    if( is_object( $qSeasons ) ) {
        foreach( $qSeasons->data as $a_season ) {
            echo( '<option value="'.$a_season[ 'season_id' ].'" '.
                  ( $a_season[ 'season_id' ] == $url_season_id ? 'selected' : '' ).' >'.
                  date( "Y: ", strtotime( $a_season[ 'start' ] ) ).
                  $apx_season_maintypes[ $a_season[ 'maintype' ] ].'/'.
                  $apx_season_subtypes[ $a_season[ 'subtype' ] ].
                  '</option>' );
        }
    }
    ?>
    </select>
    <input type="submit" value="<?php echo _( "Show" ) ?>" />
    </form>
    </td>
</tr>
<?php endif; ?>

<tr><td colspan="<?php echo ( $iPeriodlength * 2 + 1 ) ?>" class="apx_controlbg">

<?php
// Monatsauswahl generieren, der Einfachheit halber immer 31 Tage anzeigen

for( $i = -1; $i < 14; $i++ ) {
    $i_cur_ts = mktime( 0, 0, 0, $curdate[ 'mon' ] + $i, 1, $curdate[ 'year' ] );

    echo( '<a class="apx_plan" href="'.$apx_script.'?apx_a=plan&date_begin='.
          strftime( "%Y-%m-01&date_end=%Y-%m-31".$s_urlparam."\">[%b&nbsp;%y]", $i_cur_ts ).
          '</a> ' );
}

// Monatsweiterschalter: Datumsangaben berechnen, einfachheits halber immer um 31 Tage zurueckgehen
$iPrvMB = $startdate - ( 3600 * 24 * 31 );
$iPrvME = $startdate - ( 3600 * 24 );
$iNxtMB = $enddate + ( 3600 * 24 );
$iNxtME = $enddate + ( 3600 * 24 * 31 );
$iPrv2MB = $startdate - ( 3600 * 24 * 31 * 2 );
$iNxt2ME = $enddate + ( 3600 * 24 * 31 * 2 );
$iPrvWB = $startdate - ( 3600 * 24 * 7);
$iNxtWE = $enddate + ( 3600 * 24 * 7);


// Datumsangaben fuer die Query qry_dates.php und qry_plan.php
$sStartDate = date( 'Y, m, d', $startdate );
$sEndDate = date( 'Y, m, d', $enddate );

// Termindaten holen
$bShowPlan = 1;
require( $apx_root_path.'qry/qry_dates.php' );

?>
</td></tr>

<tr><td class="apx_controlbg" style="text-align:center;" rowspan="3">
<?php if( $b_showinfo ): ?>
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $iPrvMB ) ?>&date_end=<?php echo date( 'Y-m-d', $iPrvME ).$s_urlparam ?>">&lt; m</a>&nbsp;
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $iNxtMB ) ?>&date_end=<?php echo date( 'Y-m-d', $iNxtME ).$s_urlparam ?>">m &gt;</a><br>
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $iPrvWB ) ?>&date_end=<?php echo date( 'Y-m-d', $enddate ).$s_urlparam ?>">&lt;+w</a>&nbsp;
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $startdate ) ?>&date_end=<?php echo date( 'Y-m-d', $iNxtWE ).$s_urlparam ?>">w+&gt;</a><br>
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $iPrvMB ) ?>&date_end=<?php echo date( 'Y-m-d', $enddate ).$s_urlparam ?>">&lt;+m</a>&nbsp;
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $startdate ) ?>&date_end=<?php echo date( 'Y-m-d', $iNxtME ).$s_urlparam ?>">m+&gt;</a><br>
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $iPrv2MB ) ?>&date_end=<?php echo date( 'Y-m-d', $enddate ).$s_urlparam ?>">&lt;+2m</a>&nbsp;
    <a class="apx_plan" href="<?php echo $apx_script ?>?apx_a=plan&date_begin=<?php echo date( 'Y-m-d', $startdate ) ?>&date_end=<?php echo date( 'Y-m-d', $iNxt2ME ).$s_urlparam ?>">2m+&gt;</a>
<?php else:
    echo '<a href="'.$apx_script.'?apx_a=plan'.$s_urlparam.'">'._( "Default view" ).'</a>';
      endif;
?>
</td>

<?php

// Monats und Tageszeile generieren und in Strings schreiben
$sDayline = ''; $sMonthline = ''; $sOldMonth = '';
$iOldMonth = $aStartDate[ 'mon' ]; $iDaycount = 0; $iOldYear = 0;
$sToday = date( 'Y-m-d', time() );

// 1. Termin auslesen
$bNextDate = ( is_object( $qDates ) && $qDates->rows );
$iDateCount = 0;

// Iconabmessungen
$iPlanimg_w = intval( 20 * ( $apx_planfontsize / 9 ) );

$sDateLine = '';

// Fuer jeden Tag der anzuzeigenden Periode eine Zelle generieren
for( $i = 0; $i < $iPeriodlength; $i++ ) {
    $iCurDate = mktime( 0, 0, 0, $aStartDate[ 'mon' ], $aStartDate[ 'mday' ] + $i, $aStartDate[ 'year' ] );
    $aCurDate = getDate( $iCurDate );

    // am Ende eines jeden Monates eine Monatszelle generieren
    if ( $iOldMonth != $aCurDate[ 'mon' ] ) {
        if ( !$iDaycount )
            $iDaycount = 1;
        $sMonthline = $sMonthline."<td class=\"apx_mainbg\" colspan=\"".
                      ( $iDaycount * 2 )."\"><strong class=\"apx_plan\">$sOldMonth ($iOldMonth) $iOldYear</strong></td>\n\r";
        $iDaycount = 0;
    }
    if( date( 'Y-m-d', $iCurDate ) == $sToday ) // Heute
        $sDayColor = 'apx_todaybg';
    elseif( $aCurDate[ 'wday' ] == 0 ) // Sonntage
        $sDayColor = 'apx_importantbg';
    else
        $sDayColor = 'apx_headerbg2';

    $sDayline = $sDayline."<td class=\"$sDayColor\" colspan=\"2\"><span class=\"apx_plan\">".
                strftime( "%a", $iCurDate )."<br />".$aCurDate[ 'mday' ]."</span></td>\n\r";


    // Terminzelle an Terminzeile anfuegen
    if( $bNextDate ) {
        $iDateYear = substr( $qDates->data[ $iDateCount ][ 'thedate' ], 0, 4 );
        $iDateMonth = substr( $qDates->data[ $iDateCount ][ 'thedate' ], 5, 2 );
        $iDateDay = substr( $qDates->data[ $iDateCount ][ 'thedate' ], 8, 2 );
    }
    else {
        $iDateMonth = 0; $iDateDay = 0; $iDateYear = 0;
    }

    $bDatesWritten = false;
    $sDateLine .= '<td class="apx_mainbg" colspan="2">';

    while( ( mktime( 0, 0, 0, $iDateMonth, $iDateDay, $iDateYear ) == $iCurDate ) && $bNextDate ) {
        $sDateLine .= '<a href="'.$apx_script.
                  '?apx_a=date&do=u&id='.
                  $qDates->data[ $iDateCount ][ 'date_id' ].
                  '&backaction=plan"><img style="margin-bottom:1pt" src="'.
                  $apx_imgpath.'sym_info'.
                  $qDates->data[ $iDateCount ][ 'priority' ].
                  '.gif" height="'.$iPlanimg_w.'" width="'.
                  $iPlanimg_w.'" title="'.
                  $apx_DatePriorities[ $qDates->data[ $iDateCount ][ 'priority' ] ].': '.
                  $qDates->data[ $iDateCount ][ 'notice' ].'"></a><br>';

        // nchsten Termin holen
        if( ++$iDateCount < $qDates->rows ) {
            $bNextDate = true;

            $iDateYear = substr( $qDates->data[ $iDateCount ][ 'thedate' ], 0, 4 );
            $iDateMonth = substr( $qDates->data[ $iDateCount ][ 'thedate' ], 5, 2 );
            $iDateDay = substr( $qDates->data[ $iDateCount ][ 'thedate' ], 8, 2 );
        }
        else
            $bNextDate = false;

        $bDatesWritten = true;
    }
    if ( !$bDatesWritten )
        $sDateLine .= '&nbsp';

    $bDatesWritten = false;

    $sDateLine .= '</td>';


    $sOldMonth = strftime( "%B", $iCurDate );
    $iOldMonth = $aCurDate[ 'mon' ];
    $iOldYear = $aCurDate[ 'year' ];
    $iDaycount++;
}

// Letzten Monat hinzufuegen
$sMonthline = $sMonthline."<td class=\"apx_mainbg\" colspan=\"".
              ( $iDaycount * 2 )."\"><strong class=\"apx_plan\">$sOldMonth ($iOldMonth) $iOldYear</strong></td>\n\r";

// Wenn sMonthline leer, dann wurde der Monat gar nicht gewechselt
if( $sMonthline == '' )
  $sMonthline = "<td class=\"apx_mainbg\" colspan=\"".
                ( $iDaycount * 2 )."\">$sOldMonth $iOldYear</td>\n\r";

echo( $sMonthline );

echo( "</tr><tr>\n\r" );

// Wochenzeile
$iFirstWeek = intval( $aStartDate[ 'yday' ] / 7 ) + 1;
$iOffset = $aStartDate[ 'wday' ]; // 1 bis 6, so = 0
if( $iOffset == 0 ) $iOffset = 7;

if( $iPeriodlength >= 7 ) {
    $iFirstDays = 7 - $iOffset + 1;
    $iWeeks = intval( ( $iPeriodlength - $iFirstDays ) / 7 );
    $iLastDays = $iPeriodlength - ( $iWeeks * 7 ) - $iFirstDays;
}
else {
    $iFirstDays = $iPeriodlength;
    $iWeeks = 0;
    $iLastDays = 0;
}

// 1. Woche
if( $iFirstDays )
    echo( "<td class=\"apx_mainbg\" colspan=\"".( $iFirstDays * 2 ).
          "\"><span class=\"apx_plan\">".$iFirstWeek.". "._( "Week" )." </span></td>\n\r" );

// Volle Wochen
for( $i = 1; $i <= $iWeeks; $i++ ) {
    $iCurWeek = ( $iFirstWeek + $i ) % 52;
    echo( "<td class=\"apx_mainbg\" colspan=\"14\"><span class=\"apx_plan\">".
          ( $iCurWeek ? $iCurWeek : 52 ).". "._( "Week" )." </span></td>\n\r" );
}

// Letzte Woche
if( $iLastDays ) {
    $iCurWeek = ( $iFirstWeek + $iWeeks + 1 ) % 52;
    echo( "<td class=\"apx_mainbg\" colspan=\"".
          ( $iLastDays * 2 )."\"><span class=\"apx_plan\">".
          ( $iCurWeek ? $iCurWeek : 52 ).". "._( "Week" )." </span></td>\n\r" );
}

echo( "</tr>
       <tr>\n\r" );

echo( $sDayline );

echo( "</tr>\n\r" );

// Terminzeile ausgeben
if( $b_showinfo ) {
    echo( '<tr><td class="apx_controlbg">
        <a href="'.$apx_script.'?apx_a=datedb">
        <span class="apx_plan">'._( "Dates" ).'
        </span></a></td>'.$sDateLine.'</tr>' );
}

// Hoehe einer Raumzeile ermitteln
if( $apx_spanplan && $qRoomCount->data[ 0 ][ 'roomcount_show' ] != 0 ) {
    $iLineheight = intval( $apx_maxplanheight /
                           $qRoomCount->data[ 0 ][ 'roomcount_show' ] );
}
else {
    $iLineheight = 1;
}

// Datenstrukturen, um fehlerhafte Buchungen zu protokollieren
$plan_faultbooking_count = 0;
$plan_faultbookings = array();

if( is_object( $qRoomData ) && $qRoomData->rows ):

// Fuer jeden Raum eine Tabellenzeile ausgeben
foreach( $qRoomData->data as $rowRoomData ) {
    $qr_room_id     = $rowRoomData[ 'room_id' ];
    $qr_capacity    = $rowRoomData[ 'capacity' ];
    $qr_number      = $rowRoomData[ 'roomnumber' ];
    $qr_objnr       = $rowRoomData[ 'objnr' ];
    $qr_objname     = $rowRoomData[ 'objname' ];
    $qr_object_id   = $rowRoomData[ 'object_id' ];

    if( trim( $qr_roomname = $rowRoomData[ 'roomname' ] ) == '' )
        $qr_roomname = $qr_number._( ' (no desc.)' );

    echo( "<tr><td class=\"apx_controlbg\" nowrap=\"yes\" >\n" );

    if( $apx_plan_shortdesc ) {
        echo( "<a href=\"$apx_script?apx_a=plan&planobj_id=$qr_object_id".$s_urlparam_s.
              "\">[$qr_objnr]</a>&nbsp;\n".
              "<a class=\"apx_plan\" href=\"$apx_script?apx_a=plan&planroom_id=$qr_room_id".
              $s_urlparam_s."\">\n($qr_number)&nbsp;$qr_roomname</a>\n" );
    }
    else {
        echo( "<table class=\"apx_layout\"><tr>\n<td>" );

        if( $b_showinfo )
            echo( "<span class=\"apx_plan_tiny\"><strong>"._( "Room" ).
                  " $qr_number</strong> ($qr_capacity P.)<br />\n".
                  "<a class=\"apx_plan\" href=\"$apx_script?apx_a=plan&planroom_id=$qr_room_id".
                  $s_urlparam_s."\">\n" );

        echo( "$qr_roomname&nbsp;" );

        if( $b_showinfo )
            echo( "</a><br /><a class=\"mgtxtsmall\"
                  href=\"$apx_script?apx_a=plan&planobj_id=$qr_object_id".$s_urlparam_s.
                  "\">[$qr_objnr]</a> $qr_objname\n</span>" );

        echo( "</td>\n" );

        if( $b_showinfo )
            echo( "<td><img src=\"".$apx_imgpath."pix_invisible.gif\" height=\"$iLineheight\"
                  width=\"1\" align=\"left\"></td>\n" );

        echo( "</tr></table>\n" );
    }

    echo( "</td>\n" );

    // Daten holen
    require( $apx_root_path.'qry/qry_plan.php' );

    $iCurDPos = $startdate;
    $iCellCount = 0;

    // Alle Buchungen fuer diesen Raum in einer Zeile ausgeben
    if( is_object( $qPlan ) && $qPlan->rows ):

    foreach( $qPlan->data as $rowPlan ) {
        $bEntryOverride     = false;
        $bEntryUnderride    = false;
        $bEntryOverlap      = false;

        // Gstedaten
        $sCurLastname   = $rowPlan[ 'lastname' ];
        $iCurCus_id     = $rowPlan[ 'customer_id' ];
        $iCurBooking_id = $rowPlan[ 'booking_id' ];
        $iCurPers       = $rowPlan[ 'persons' ];
        $sCurNotice     = $rowPlan[ 'notice' ];
        $qr_is_inquiry  = $rowPlan[ 'is_inquiry' ];
        $qr_reported    = $rowPlan[ 'reported' ];
        $qr_checkedin   = $rowPlan[ 'checkedin' ];

        // Datumsberechnungen fuer colspan-Eintrge
        $sCurSDate      = $rowPlan[ 'date_begin' ];
        $sCurEDate      = $rowPlan[ 'date_end' ];

        $s_year         = substr( $sCurSDate, 0, 4 );
        $s_month        = substr( $sCurSDate, 5, 2 );
        $s_day          = substr( $sCurSDate, 8, 2 );
        $iCurSDate      = mktime( 0, 0, 0, $s_month, $s_day, $s_year );

        $e_year         = substr( $sCurEDate, 0, 4 );
        $e_month        = substr( $sCurEDate, 5, 2 );
        $e_day          = substr( $sCurEDate, 8, 2 );
        $iCurEDate      = mktime( 0, 0, 0, $e_month, $e_day, $e_year );

        // Datumsintervalle berechnen
        $iCurDLength    = $iCurEDate - $iCurSDate;
        $iCurDOffset    = $iCurSDate - $iCurDPos;

        // Ueberpruefen, ob Eintrge den Anzeigebereich ueberschreiten (oben u. unten)
        if( $iCurDOffset < 0 ) { // nach links/unten-Uebertretung korrigieren
            $iCurDLength += $iCurDOffset; // Offset negativ, deshalb +=!
            $iCurDOffset = 0;

            // wenn $iCurDLength <= 0, dann ist Ueberlappung groesser als
            // Laenge der aktuellen Buchung, also vollstaendig
            // --> Behandlung: Diese Buchung wird
            // nicht angezeigt! Notwendiger Darstellungsfehler wird so
            // unterbunden
            if ($iCurDLength <= 0 && $iCellCount) {
                $plan_faultbookings[$plan_faultbooking_count++] =
                    array($iCurBooking_id, $sCurLastname);
                continue;
            }

            // Wenn sich zwei Gaestebereiche ueberlappen (wird mit $iCellCount != 0 geprueft),
            // dann ist iCurDOffset auch < 0 aber
            // es darf kein $bEntryUnderride geben sondern nur einen speziellen Ueberlappungshinweis
            if ( $iCellCount )
                $bEntryOverlap = true;
            else
                $bEntryUnderride = true;
        }
        if ( $enddate < $iCurEDate ) { // nach rechts/oben-Uebertretung korrigieren
            $iCurDLength -= ($iCurEDate - $enddate);

            // letzter Tag wird noch ganz angezeigt --> + 3600 * 24
            $iCurDLength += (3600 * 24);

            $bEntryOverride = true;
        }

        // Alte Werte fuer apxPrintEmptySpace
        $i_old_pos    = $iCurDPos;
        $i_old_offset = $iCurDOffset;

        // Gast bleibt von Mitte des 1. bis Mitte des letzten Tages,
        // im Gegensatz zu plan_fullday keinen Tag dazuzaehlen
        $iCurDPos += $iCurDLength + $iCurDOffset;

        // Anzahl der Tage, die zu markieren sind. ( fuer aktuellen Datensatz )
        $aCurDLength = getdate( $iCurDLength );
        $years = $aCurDLength[ 'year' ] - 1970;
        $days = $aCurDLength[ 'yday' ];
        $iCurDLength = ( $years * 365 ) + intval( $years / 4 ) + $days;

        // Anzahl der Tage, die zu freizulassen sind ( vor aktuellem Datensatz )
        $aCurDOffset = getdate( $iCurDOffset );
        $years = $aCurDOffset[ 'year' ] - 1970;
        $days = $aCurDOffset[ 'yday' ];
        $iCurDOffset = ( $years * 365 ) + intval( $years / 4 ) + $days;

        // Leerbereich ausgeben
        if( $iCurDOffset ) {
            if( !$iCellCount )
                $iEmptyColSpan = ( $iCurDOffset * 2 ) + 1; // Erster Leerbereich
            else
                $iEmptyColSpan = ( $iCurDOffset * 2 ); // Leerbereich mittendrin

            apxPrintEmptySpace( $iEmptyColSpan, $qr_room_id, $i_old_pos,
                                $i_old_offset, $apx_plan_emptyspaces, $b_showinfo );

            $iCellCount += $iEmptyColSpan;
        }
        elseif( !$iCellCount && !$bEntryUnderride && !$bEntryOverlap ) {
            apxPrintEmptySpace( 1, $qr_room_id, $i_old_pos,
                                $i_old_offset, $apx_plan_emptyspaces, $b_showinfo );
            $iCellCount++;
        }

        // Gastbereich ausgeben
        $iColspanAdd_l = ( $bEntryUnderride ?  1 : 0 );
        $iColspanAdd_r = ( $bEntryOverride ?  1 : 0 );

        if( $bEntryOverlap )
            $iColspan = $iCurDLength * 2 - $iColspanAdd_r;
        else
            $iColspan = $iCurDLength * 2 + $iColspanAdd_l - $iColspanAdd_r;


        echo( '<td class="' );

        // Farbliche Kennzeichnung von gerade anzuzeigenden Buchungen und Anfragen
        // nach Prioritaeten abgefragt
        if( $b_showinfo ) {
            if( $iCurBooking_id == $i_hl_booking )
                echo( 'apx_entrybghl' );
            elseif( $qr_checkedin == 2 )
                echo( 'apx_checkedin' );
            elseif( $qr_is_inquiry )
                echo( 'apx_inquiry' );
            else
                echo( 'apx_entrybg' );
        }
        else
            echo( $iCurBooking_id == $i_hl_booking ? 'apx_entrybghl' : 'apx_entrybg' );

        echo( '" colspan="'.$iColspan.'">'."\n" );

        if( $b_showinfo ) {
            if( $bEntryUnderride )
                echo( '<span class="apx_plan"
                      style="color:#FFFFFF; font-weight:bold; background:#FF0000">'.
                      '&nbsp;&laquo;&nbsp;</span>'."\n".
                      ( $apx_plan_shortdesc ? '' : ' <span style="color:white" class="apx_plan_tiny">'.
                      substr( $sCurSDate, 0, 11 ).', </span>' ).
                      "\n" );
            elseif( $bEntryOverlap )
                echo( '<span style="color:#FFFFFF; font-weight:bold; background:#FF0000" class="apx_plan">'.
                      '&nbsp;!!&nbsp;</span>'."\n".
                      ( $apx_plan_shortdesc ? '' : ' <span style="color:white" class="apx_plan_tiny">'.
                      substr( $sCurSDate, 0, 11 ).', </span>' ).
                      "\n" );

            echo( '<a class="apx_plan" href="'.$apx_script.'?apx_a=booking&do=u&id='.
                   $iCurBooking_id.'&backaction=plan">'."\n".
                   '<img src="'.$apx_imgpath.'sym_customer.gif" width="'.$iPlanimg_w.
                   '" height="'.$iPlanimg_w.'" title="'._( "Edit booking" ).'" align="middle" '."\n".
                   ' onMouseover="return dispStatus(\''._( "Edit booking" ).'\')" '.
                   ' onMouseout="return dispStatus(\'\')"></a>'."\n" );

            // Gaesteinfo
            if( trim( $sCurNotice ) != '' )
                echo(  ' <a href="javascript:openwindow_write( \'infowindow\', \'resizable=yes,height=20,width=300\', \'(<strong>'.
                       $sCurLastname.'</strong>) '.$sCurNotice.'\' )">'."\n".
                       '<img onMouseover="return dispStatus(\''.$sCurNotice.'\')" '."\n".
                       ' onMouseout="return dispStatus(\''.$apx_versioninfo.'\')"'."\n".' src="'.
                       $apx_imgpath.'sym_info.gif" width="'.$iPlanimg_w.'" height="'.$iPlanimg_w.'"
                       title="'.$sCurNotice.'" align="middle"></a> '."\n" );

            echo( ' <a class="apx_plan" href="'.$apx_script.'?apx_a=booking&do=u&id='.
                   $iCurBooking_id.'&backaction=plan">'.
                   $sCurLastname.'</a>'."\n".
                   ( $apx_plan_shortdesc ? '' : '<span class="apx_plan_tiny">, '.$iCurPers._( ' P.' ).'</span>' ).
                   "\n" );

            // Wenn Personenzahl > Raumgroesse
            if( $iCurPers > $qr_capacity )
                echo ( '<span class="apx_plan_tiny" style="color:red">, '._( "overcrowded!" ).'</span>'."\n" );

            if( $bEntryOverride )
                echo( ( $apx_plan_shortdesc ? '' : ', <span class="apx_plan_tiny" style="color:white">'.
                      substr( $sCurEDate, 0, 11 ).'</span>' )."\n".
                      ' <span style="color:#FFFFFF; font-weight:bold; background:#FF0000"
                      class="apx_plan">&nbsp;&raquo;&nbsp;</span>'.
                      "\n" );
        }
        else {
            echo '&nbsp;&nbsp;'._( "Already occupied." );
        }

        echo( "</td>\n" );

        $iCellCount += $iColspan;

        // Ausnahme: Wenn $iCurDPos >= $enddate ist, dann
        // darf kein Buchungseintrag mehr ausgegeben werden. Das wuerde vorkommen,
        // wenn sich zwei Eintraege ueberlappen und der fruehere Eintrag aber schon
        // bis zum Ende der Anzeigeperiode geht, der spaetere vor deren Ende beginnt.
        if( $iCurDPos >= $enddate )
            break;
    }

    endif; // foreach ( $qPlan ...

    // Verbleibende Leerzellen ( mind. 1 ) schreiben und Tabellenzeile abschliessen (letzter Leerbereich)
    if ( ($iPeriodlength * 2) - $iCellCount ) {
        $iColspan = ($iPeriodlength * 2) - $iCellCount;
        apxPrintEmptySpace( $iColspan, $qr_room_id, $iCurDPos,
                            86400, $apx_plan_emptyspaces, $b_showinfo );
    }
    elseif ( !$bEntryOverride )
        apxPrintEmptySpace( 1, $qr_room_id, $iCurDPos,
                            86400, $apx_plan_emptyspaces, $b_showinfo );

}

endif; // foreach ( $qRoomData ...

?>
</table>

<?php

// Evtl. fehlerhafte Buchungen ausgeben
for( $i = 0; $i < count($plan_faultbookings); $i++ ) {
    trigger_error( $apx_errors[ 9 ].
                 ' <br><strong>'._( "Booking-ID" ).': '.$plan_faultbookings[$i][0].
                 _( ', Concerning booking' ).': </strong><a href="'.$apx_script.
                 '?apx_a=booking&do=u&id='.$plan_faultbookings[$i][0].
                 '&backaction=plan">'.$plan_faultbookings[$i][1].'</a>' , E_USER_WARNING );
}

// Wenn keine Raeumlichkeiten angezeigt werden
if( $qRoomCount->data[ 0 ][ 'roomcount_show' ] == 0 )
    trigger_error( $apx_messages[ 2 ], E_USER_NOTICE );

if( !$b_showinfo )
    trigger_error( $apx_messages[ 16 ], E_USER_WARNING );

// if-close zu "Anzeigeperiode zu lang"
endif;
?>

