<?php // $Id: index.php,v 1.33 2004/10/11 10:42:43 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

require_once( "./act_lib.php" );

apxGuard( 'apx_root_path' ); // @SECURITY

require_once( "./app_globals.php" );
require( './act/act_authenticate.php' );
include( './dsp/dsp_header.php' );
require( './act/act_check_access.php' );



if( $bAccess ) {

switch( $apx_a ) {
    case 'login':         include './dsp/dsp_login.php';             break;
    case 'logout':        include './dsp/dsp_logout.php';            break;

    case 'logostart':     include './dsp/dsp_logostart.php';         break;

    case 'adminmenu':     include './dsp/dsp_adminmenu.php';         break;

    case 'plan':
        include './dsp/dsp_date_reminder.php';
        include './dsp/dsp_plan.php';
        break;

    case 'searchfree':    include './dsp/dsp_form_searchfree.php';   break;

    case 'credits':       include './dsp/dsp_credits.php';           break;

    case 'help':          include './dsp/dsp_help.php';              break;

    case 'roomdb':        include './dsp/dsp_rooms.php';             break;
    case 'room':          include './dsp/dsp_form_room.php';         break;

    case 'objectdb':      include './dsp/dsp_objects.php';           break;
    case 'object':        include './dsp/dsp_form_object.php';       break;

    case 'seasondb':      include './dsp/dsp_seasons.php';           break;
    case 'season':        include './dsp/dsp_form_season.php';       break;

    case 'datedb':        include './dsp/dsp_dates.php';             break;
    case 'date':          include './dsp/dsp_form_date.php';         break;
    case 'datereminder_off': include './act/act_date_reminder.php';  break;

    case 'countrydb':     include './dsp/dsp_countries.php';         break;
    case 'country':       include './dsp/dsp_form_country.php';      break;

    case 'bookingdb':     include './dsp/dsp_bookings.php';          break;
    case 'booking':       include './dsp/dsp_form_booking.php';      break;

    case 'inquiry':       include './dsp/dsp_form_inquiry.php';      break;

    case 'bookingexport': case 'bookingimport':
        include './dsp/dsp_booking_export_import.php';
        break;
    case 'bookingexport_do': case 'bookingimport_do':
        include './act/act_booking_export_import.php';
        break;

    case 'booking_report': 
        include './act/act_booking_export_import.php';
    	include './dsp/dsp_booking_report.php';
    	break;
    	
    case 'booking_report_do':
    	include './act/act_booking_report.php';
    	break;
        
    case 'customerdb':    include './dsp/dsp_customers.php';         break;
    case 'customer':      include './dsp/dsp_form_customer.php';     break;

    case 'bk_accountdb':  include './dsp/dsp_bk_accounts.php';       break;
    case 'bk_account':    include './dsp/dsp_form_bk_account.php';   break;
    case 'bk_entrydb':    include './dsp/dsp_bk_entries.php';        break;
    case 'bk_entry':      include './dsp/dsp_form_bk_entry.php';     break;

    case 'stats':         include './dsp/dsp_form_stats.php';        break;

    case 'editordb':      include './dsp/dsp_editors.php';           break;
    case 'editor':        include './dsp/dsp_form_editor.php';       break;

    case 'nextcustomers': include './dsp/dsp_nextcustomers.php';     break;

    case 'customerpr':
        require './qry/qry_customers.php';
        require './act/act_proc_labelset.php';
        include './dsp/dsp_form_print.php';
        break;

    case 'billpr':        include './dsp_print.php';             break;

    case 'labelprint':
        include( './act/act_proc_labelset.php' );
        if( apxIsPost( 'customerpr_submit' ) ) {
            include './dsp/dsp_labels.php';
		// 	if( $_POST[ 'outformat' ] == 'css' ||
		// 		$_POST[ 'outformat' ] == 'html' ||
	    //         $_POST[ 'outformat' ] == 'text' ||
	    //         $_POST[ 'outformat' ] == 'excel' ) {
	    //       include './dsp/dsp_labels_'.$_POST[ 'outformat' ].'.php';
	
	    //     } else
	    //       trigger_error( _( 'This format is not supported yet!' ).
	    //                         ' <a href="javascript:history.back()">'._( "Back" ).'</a>',
	    //                         E_USER_WARNING );
        }
        break;

    case 'changeperiod':  include './dsp/dsp_form_chper.php';        break;

    case 'search':
        require './qry/qry_countries.php';
        include './dsp/dsp_form_search.php';
        break;

    case 'syscheck':      include './act/act_syscheck.php';          break;
    case 'config':        include './dsp_form_config.php';           break;
    case 'savecfg':
        trigger_error( _( "Configuration data has been saved successfully. Now, the application will run with the new configuration." ),
                        E_USER_NOTICE );
        break;
    case 'getcfg':        include './act_proc_config.php';           break;

    case 'create_cusmail': include './dsp/dsp_form_mail.php';        break;
    case 'send_cusmail':  include './act/act_proc_mail.php';         break;
    case 'exec_ext_mailer': include './act/act_exec_ext_mailer.php'; break;

    case 'emaillist':
        include './qry/qry_emailadr.php';
        include './dsp/dsp_emaillist.php';
        break;

    case 'dbbackup':      include './act/act_dbbackup.php';          break;

    case 'guestreg': case 'guestreg_save':
    default:
        // Keinen Zugriff zu dieser Fuseaction
        trigger_error( $apx_errors[11], E_USER_WARNING );
}

}
else
    // Keinen Zugriff zu dieser Fuseaction
    trigger_error( $apx_errors[11], E_USER_WARNING );

include( './dsp/dsp_footer.php' );

if( $apx_debug ) {
    echo( '<div class="wide"><p>[mg.applanix - debugging output:begin]</p>' );
    $s_incfiles = get_included_files();
    foreach($s_incfiles as $s_filename)
       echo "$s_filename <br />";
    echo( "<p>[mg.applanix - debugging output:end]</p></div>" );

    phpinfo();
}

if( $apx_db_debug )
    $apx_dbc->error();

$apx_dbc->close();

?>
